<template>
  <div class="flex justify-center">
    <div class="full-width q-pa-xl">
      <h6 v-if="MyTasks.length > 0" class="q-my-none q-mb-md">My Tasks</h6>
      <h6 v-else class="q-my-none q-mb-md">No Pending Tasks</h6>
      <q-form
        ref="form"
        @submit.prevent="!selectedTodo ? addTodo() : updateTodo()"
      >
        <div class="row gap">
          <q-input
            ref="todoField"
            v-model="text"
            dense
            outlined
            label="What's your todo?"
            class="q-pa-none col-10"
            lazy-rules
            :rules="[(val) => !!val || 'Field is required']"
          />

          <div class="col-2 q-pl-sm">
            <q-btn
              :class="`bg-${!selectedTodo ? 'primary' : 'secondary'} fit`"
              color="white"
              glossy
              dense
              flat
              type="submit"
              :icon="!selectedTodo ? 'add' : 'edit'"
            />
          </div>
        </div>
      </q-form>
      <div class="q-mt-xl">
        <q-card
          @click="selectTodo(task)"
          class="q-mt-sm"
          v-for="task in MyTasks"
          :key="task.id"
        >
          <q-card-section
            :class="`bg-${
              selectedTodo && selectedTodo.id === task.id
                ? 'secondary'
                : 'primary'
            } text-white q-pa-none flex justify-between items-center`"
          >
            <div class="text-bold q-pl-lg">{{ task.todo }}</div>
            <div class="bg-white q-pa-sm">
              <q-btn
                @click.stop="toggleDialog(task, 'done')"
                flat
                icon="check_circle_outline"
                color="green"
              />
              <q-btn
                @click.stop="toggleDialog(task, 'delete')"
                flat
                icon="delete_outline"
                color="red"
              />
            </div>
          </q-card-section>
        </q-card>
      </div>
    </div>
  </div>

  <q-dialog v-model="showDialog" persistent>
    <q-card>
      <q-card-section class="row items-center">
        <div v-if="toMarkAsDone" class="q-ml-sm">
          Are you sure you want to mark
          <span class="text-green">"{{ toMarkAsDone.todo }}"</span> as done?
        </div>
        <div v-else class="q-ml-sm">
          Are you sure you want to delete
          <span class="text-red">"{{ toDelete.todo }}"</span>?
        </div>
      </q-card-section>

      <q-card-actions align="right">
        <q-btn flat label="Cancel" color="primary" v-close-popup />
        <q-btn
          @click="toMarkAsDone !== null ? markAsDone() : removeTodo()"
          flat
          label="Yes"
          color="primary"
          v-close-popup
        />
      </q-card-actions>
    </q-card>
  </q-dialog>
</template>

<script setup>
import { MyTasks, FinishedTasks, DeletedTasks } from "../composables/Tasks"; // composables

import { ref } from "vue";

/** ------------------------------- QUASAR TODO APP PROPERTIES ------------------------------- */
let text = ref(null); // A todo value of the input field.
let form = ref(null); // the form that contains the add task button and the input field.
let todoField = ref(null); // the input field of the form
let selectedTodo = ref(null); // the reference for the task to be updated.
let showDialog = ref(false); // the property for showing the confirmation dialog.
let toMarkAsDone = ref(null); // the reference for the task to be marked as done.
let toDelete = ref(null); // the reference for the task to be removed.
/** -------------------------------- END OF QUASAR TODO APP PROPERTIES -------------------------------- */

/** -------------------------------- UTILITY FUNCTIONS FOR QUASAR TODO APPLICATIONS -------------------------------- */

/**
 * function selectTodo(row)
 *
 * @description
 * - A function that selects/sets the selected task to be updated.
 *
 * @param row : Object
 * - A task to be updated.
 */
const selectTodo = (row) => {
  selectedTodo.value = row;
  text.value = row.todo;
};

/**
 * function toggleDialoge(row, status)
 *
 * @description
 * - A function that shows the confirmation dialog.
 *
 * @param row
 * - The task to be selected based on @param status.
 *
 * @status
 * - Status on what process to be executed. If the status is equal to "delete",
 * the process will be deleting a task, otherwise, the process will be updating the task.
 */
const toggleDialog = (row, status) => {
  showDialog.value = true;

  toMarkAsDone.value = toDelete.value = null;

  status !== "delete" ? (toMarkAsDone.value = row) : (toDelete.value = row);
};
/** -------------------------------- END OF UTILITY FUNCTIONS FOR QUASAR TODO APP -------------------------------- */

/** -------------------------------- MAIN FUNCTIONS OF QUASAR TODO APP -------------------------------- */

/**
 * function addTodo()
 *
 * @description
 * - A function that adds new todo to MyTasks list.
 */
const addTodo = () => {
  let id = MyTasks.value.length;

  MyTasks.value.push({
    id: ++id,
    todo: text.value,
  });

  text.value = null;
  form.value.reset();
  todoField.value.focus();
};

/**
 * function updateTodo()
 *
 * @description
 * - A function that updates the @property selectedTodo.
 */
const updateTodo = () => {
  let index = MyTasks.value.findIndex((t) => t.id === selectedTodo.value.id);

  index !== -1 && (MyTasks.value[index].todo = text.value);

  text.value = selectedTodo.value = null;

  form.value.reset();
};

/**
 * function markAsDone()
 *
 * @description
 * - A function that sets the @property selectedTodo as "FINISHED"
 */
const markAsDone = () => {
  let index = MyTasks.value.findIndex((t) => t.id === toMarkAsDone.value.id);

  index !== -1 && MyTasks.value.splice(index, 1);

  FinishedTasks.value.push(toMarkAsDone.value);

  toMarkAsDone.value = null;

  showDialog.value = false;
};

/**
 * function removeTodo()
 *
 * @description
 * - A function that removes the @property selectedTodo.
 */
const removeTodo = () => {
  let index = MyTasks.value.findIndex((t) => t.id === toDelete.value.id);

  index !== -1 && MyTasks.value.splice(index, 1);

  DeletedTasks.value.push(toDelete.value);

  toDelete.value = null;

  showDialog.value = false;
};
</script>
